=== debian/changelog ===
dm-tree (0.1.8-3build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:45:38 +1100

dm-tree (0.1.8-3build1) noble; urgency=high

  * No change rebuild against libabsl20220623t64.

 -- Julian Andres Klode <juliank@ubuntu.com>  Fri, 22 Mar 2024 16:55:17 +0100

dm-tree (0.1.8-3) unstable; urgency=low

  * Add patch to resolve circular imports of tree._tree (Closes: #1055686).

 -- Michael Fladischer <fladi@debian.org>  Fri, 19 Jan 2024 20:58:35 +0000

dm-tree (0.1.8-2) unstable; urgency=medium

  * Remove autopkgtest-pkg-pybuild testsuite from d/control. We provide our
    own autopkgtests.

 -- Michael Fladischer <fladi@debian.org>  Mon, 06 Nov 2023 17:45:27 +0000

dm-tree (0.1.8-1) unstable; urgency=low

  * Initial release (Closes: #1042901).

 -- Michael Fladischer <fladi@debian.org>  Wed, 02 Aug 2023 14:10:25 +0000
