=== debian/control ===
Source: dm-tree
Section: python
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Python Team <team+python@tracker.debian.org>
Uploaders:
 Michael Fladischer <fladi@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 dh-python,
 libabsl-dev,
 pybind11-dev,
 pybuild-plugin-pyproject,
 python3-absl,
 python3-all,
 python3-all-dev,
 python3-attr,
 python3-numpy,
 python3-pybind11,
 python3-pytest,
 python3-setuptools,
 python3-sphinx,
 python3-sphinx-rtd-theme,
 python3-wrapt,
Standards-Version: 4.6.2
Homepage: https://github.com/deepmind/tree
Vcs-Browser: https://salsa.debian.org/python-team/packages/python-dm-tree
Vcs-Git: https://salsa.debian.org/python-team/packages/python-dm-tree.git
Rules-Requires-Root: no

Package: python-dm-tree-doc
Section: doc
Architecture: all
Depends:
 ${misc:Depends},
 ${sphinxdoc:Depends},
Description: library for working with nested data structures (Documentation)
 A library for working with nested data structures. In a way, tree generalizes
 the builtin map function which only supports flat sequences, and allows one to
 apply a function to each "leaf" preserving the overall structure.
 .
 It is backed by an optimized C++ implementation suitable for use in demanding
 applications, such as machine learning models.
 .
 This package contains the documentation.

Package: python3-dm-tree
Architecture: any
Depends:
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: library for working with nested data structures (Python3 version)
 A library for working with nested data structures. In a way, tree generalizes
 the builtin map function which only supports flat sequences, and allows one to
 apply a function to each "leaf" preserving the overall structure.
 .
 It is backed by an optimized C++ implementation suitable for use in demanding
 applications, such as machine learning models.
 .
 This package contains the Python 3 version of the library.
