=== debian/changelog ===
dm-tree (0.1.9-1build2) resolute; urgency=medium

  * No-change rebuild with Python 3.14 as supported version

 -- Graham Inggs <ginggs@ubuntu.com>  Mon, 20 Oct 2025 14:00:39 +0000

dm-tree (0.1.9-1build1) questing; urgency=medium

  * Rebuild against latest abseil

 -- Jeremy Bícha <jbicha@ubuntu.com>  Thu, 01 May 2025 14:27:19 -0400

dm-tree (0.1.9-1) unstable; urgency=low

  * New upstream version 0.1.9
  * Refresh patches.
  * Use dh-sequence-python3.
  * Bump Standards-Version to 4.7.0.
  * Update year in d/copyright.
  * Run wrap-and-sort -bast to reduce diff size of future changes.

 -- Michael Fladischer <fladi@debian.org>  Tue, 25 Feb 2025 08:51:12 +0000
