=== debian/rules ===
#! /usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export PYBUILD_NAME=dm-tree

%:
	dh $@ --with python3,sphinxdoc --buildsystem=pybuild

execute_before_dh_sphinxdoc:
ifeq (,$(findstring nodoc, $(DEB_BUILD_OPTIONS)))
	cd $$(pybuild --print build_dir --name dm-tree |head -n1 |awk -F ': ' '{print $$2}'); python3 -m sphinx -b html -N $(CURDIR)/docs $(CURDIR)/debian/python-dm-tree-doc/usr/share/doc/python-dm-tree-doc/html
endif
